library(dplyr) 


# group by gui mapper
final_all %>%
  group_by(gui_mapper) %>%
  summarize(
            precision_sd = sd(accuracy_precision*100, na.rm = TRUE),
            recall_sd = sd(accuracy_recall*100, na.rm = TRUE),
            distance_sd = sd(distance, na.rm = TRUE),
            reduction_sd = sd(reduction*100, na.rm = TRUE),
            number = n())


# group by gui mapper
final_12 %>%
  group_by(gui_mapper) %>%
  summarize(
    precision_sd = sd(accuracy_precision*100, na.rm = TRUE),
    recall_sd = sd(accuracy_recall*100, na.rm = TRUE),
    distance_sd = sd(distance, na.rm = TRUE),
    reduction_sd = sd(reduction*100, na.rm = TRUE),
    number = n())


# shopping_self
# group by gui mapper
shopping_self %>%
  group_by(gui_mapper) %>%
  summarize(precision = mean(accuracy_precision*100, na.rm = TRUE),
            recall = mean(accuracy_recall*100, na.rm = TRUE),
            accuracy = mean(accuracy*100, na.rm = TRUE),
            distance = mean(distance, na.rm = TRUE),
            reduction = mean(reduction, na.rm = TRUE),
            trans_num = mean(num_trans, na.rm = TRUE),
            number = n())

# shopping_noselft
# group by gui mapper
shopping_noself %>%
  group_by(gui_mapper) %>%
  summarize(precision = mean(accuracy_precision*100, na.rm = TRUE),
            recall = mean(accuracy_recall*100, na.rm = TRUE),
            distance = mean(distance, na.rm = TRUE),
            reduction = mean(reduction, na.rm = TRUE),
            number = n())
