library(dplyr) 

no_self <- filter(final_all, source != target)
# group by gui mapper
tmp <- no_self %>%
  group_by(source, target) %>%
    summarize(
      # correct = mean(num_correct/num_src*100, na.rm = TRUE),
      # incorrect = mean(num_incorrect/num_src*100, na.rm = TRUE),
      # missed = mean(num_missed/num_src*100, na.rm = TRUE),
      # nonExist = mean(num_nonExist/num_src*100, na.rm = TRUE),
      precision = mean(accuracy_precision*100, na.rm = TRUE),
      recall = mean(accuracy_recall*100, na.rm = TRUE),
      # accuracy = mean(accuracy*100, na.rm = TRUE),
      distance = mean(distance, na.rm = TRUE),
      reduction = mean(reduction*100, na.rm = TRUE),
      num_correct = sum(num_correct, na.rm = TRUE),
      num_incorrect = sum(num_incorrect, na.rm = TRUE),
      num_missed = sum(num_missed, na.rm = TRUE),
      num_nonExist = sum(num_nonExist, na.rm = TRUE),
      num_events = sum(num_events, na.rm = TRUE),
      number = n()) %>%
        arrange( desc(precision) )

# group app pairs

app_pairs_merged <- data.frame(matrix(ncol=15,nrow=0))
colnames(app_pairs_merged) <- c("source","target","precision","recall","distance","reduction","num_correct","num_incorrect","num_missed","num_nonExist","correct_percentage","incorrect_percentage","missed_percentage","nonExist_percentage","number")
for(i in 1:nrow(tmp))
{
  for(j in i:nrow(tmp))
  {
    if(i == j) next
    if((tmp[i,]$source == tmp[j,]$target) & (tmp[i,]$target == tmp[j,]$source))
    {
      merged_number <- tmp[i,]$number + tmp[j,]$number
      merged_precision <- ((tmp[i,]$precision * tmp[i,]$number) + (tmp[j,]$precision * tmp[j,]$number)) / merged_number
      merged_recall <- ((tmp[i,]$recall * tmp[i,]$number) + (tmp[j,]$recall * tmp[j,]$number)) / merged_number
      merged_distance <- ((tmp[i,]$distance * tmp[i,]$number) + (tmp[j,]$distance * tmp[j,]$number)) / merged_number
      merged_reduction <- ((tmp[i,]$reduction * tmp[i,]$number) + (tmp[j,]$reduction * tmp[j,]$number)) / merged_number
      merged_correct <- tmp[i,]$num_correct + tmp[j,]$num_correct
      merged_incorrect <- tmp[i,]$num_incorrect + tmp[j,]$num_incorrect
      merged_missed <- tmp[i,]$num_missed + tmp[j,]$num_missed
      merged_nonExist <- tmp[i,]$num_nonExist + tmp[j,]$num_nonExist
      total_events <- merged_correct + merged_incorrect + merged_missed + merged_nonExist
      merged_cor_per <- merged_correct * 100 / total_events
      merged_incor_per <- merged_incorrect * 100 / total_events
      merged_mis_per <- merged_missed * 100 / total_events
      merged_non_per <- merged_nonExist * 100 / total_events
      
      app_pairs_merged[nrow(app_pairs_merged)+1,] = c(tmp[i,]$source,tmp[i,]$target,merged_precision,merged_recall,merged_distance,merged_reduction,merged_correct,merged_incorrect,merged_missed,merged_nonExist,merged_cor_per,merged_incor_per,merged_mis_per,merged_non_per,merged_number)
    }
  }
}

app_pairs_merged$precision <- as.numeric(as.character(app_pairs_merged$precision))
app_pairs_merged$recall <- as.numeric(as.character(app_pairs_merged$recall))
app_pairs_merged$distance <- as.numeric(as.character(app_pairs_merged$distance))
app_pairs_merged$reduction <- as.numeric(as.character(app_pairs_merged$reduction))
app_pairs_merged$number <- as.numeric(as.character(app_pairs_merged$number))
app_pairs_merged$num_correct <- as.numeric(as.character(app_pairs_merged$num_correct))
app_pairs_merged$num_incorrect <- as.numeric(as.character(app_pairs_merged$num_incorrect))
app_pairs_merged$num_missed <- as.numeric(as.character(app_pairs_merged$num_missed))
app_pairs_merged$num_nonExist <- as.numeric(as.character(app_pairs_merged$num_nonExist))
app_pairs_merged$correct_percentage <- as.numeric(as.character(app_pairs_merged$correct_percentage))
app_pairs_merged$incorrect_percentage <- as.numeric(as.character(app_pairs_merged$incorrect_percentage))
app_pairs_merged$missed_percentage <- as.numeric(as.character(app_pairs_merged$missed_percentage))
app_pairs_merged$nonExist_percentage <- as.numeric(as.character(app_pairs_merged$nonExist_percentage))
