library("dplyr")
library("stringr")

attach(final_all)

# only wish, home, geek
tmp <- final_all[ which((source == 'home' |
                                    source == 'wish' |
                                    source == 'geek') &
                                   (target == 'home' |
                                      target == 'wish' |
                                      target == 'geek') &
                                   source != target), ]

# tmp <- filter(tmp, gui_mapper != 'craftdroid')
tmp <- tmp %>%
  group_by(gui_mapper) %>%
  summarize(
    # correct = mean(num_correct/num_src*100, na.rm = TRUE),
    # incorrect = mean(num_incorrect/num_src*100, na.rm = TRUE),
    # missed = mean(num_missed/num_src*100, na.rm = TRUE),
    # nonExist = mean(num_nonExist/num_src*100, na.rm = TRUE),
    precision = mean(accuracy_precision*100, na.rm = TRUE),
    recall = mean(accuracy_recall*100, na.rm = TRUE),
    # accuracy = mean(accuracy*100, na.rm = TRUE),
    distance = mean(distance, na.rm = TRUE),
    reduction = mean(reduction*100, na.rm = TRUE),
    number = n())


tmp_all <- final_all %>%
  group_by(gui_mapper) %>%
  summarize(
    # correct = mean(num_correct/num_src*100, na.rm = TRUE),
    # incorrect = mean(num_incorrect/num_src*100, na.rm = TRUE),
    # missed = mean(num_missed/num_src*100, na.rm = TRUE),
    # nonExist = mean(num_nonExist/num_src*100, na.rm = TRUE),
    precision = mean(accuracy_precision*100, na.rm = TRUE),
    recall = mean(accuracy_recall*100, na.rm = TRUE),
    # accuracy = mean(accuracy*100, na.rm = TRUE),
    distance = mean(distance, na.rm = TRUE),
    reduction = mean(reduction*100, na.rm = TRUE),
    number = n())

cbind(tmp[1], tmp[names(tmp)[-1]] - tmp_all[match(tmp$gui_mapper, tmp_all$gui_mapper), names(tmp)[-1]])


# only SignIn and SignUp
tmp <- final_all %>%
  filter(str_detect(method, " testSignIn()") | str_detect(method, "testSignUp()"))


# tmp <- filter(tmp, gui_mapper != 'craftdroid')
tmp <- tmp %>%
  group_by(gui_mapper) %>%
  summarize(
    # correct = mean(num_correct/num_src*100, na.rm = TRUE),
    # incorrect = mean(num_incorrect/num_src*100, na.rm = TRUE),
    # missed = mean(num_missed/num_src*100, na.rm = TRUE),
    # nonExist = mean(num_nonExist/num_src*100, na.rm = TRUE),
    precision = mean(accuracy_precision*100, na.rm = TRUE),
    recall = mean(accuracy_recall*100, na.rm = TRUE),
    # accuracy = mean(accuracy*100, na.rm = TRUE),
    distance = mean(distance, na.rm = TRUE),
    reduction = mean(reduction*100, na.rm = TRUE),
    number = n())

cbind(tmp[1], tmp[names(tmp)[-1]] - tmp_all[match(tmp$gui_mapper, tmp_all$gui_mapper), names(tmp)[-1]])


